#pragma once
#include "IAP.h"
#include <string>

#define JAVA_CLASS_PATH "com/samsung/android/sdk/iap/lib/SamsungIAPWrapper"

DECLARE_LOG_CATEGORY_EXTERN(SamsungIAP_Native, Log, All);

namespace samsung {

    class IAPJniWrapper {

    public:
        static IAPJniWrapper* getInstance();

        IAPJniWrapper();
        ~IAPJniWrapper();
        
        void setOperationMode(int mode);
        void getProductDetails(const std::string& products);
        void getOwnedList(const std::string& type);
        void startPayment(const std::string& item_id, const std::string& pass_through_param, bool success_dialog);
        void consumePurchasedItems(const std::string& itemIDs);

        // Listener
        void setListener(IAPListener* listener);
        void removeListener();
        IAPListener* getListener();

        // Callbacks
        void onGetProducts(int result, const FString& msg, const std::string& data);
        void onGetOwnedProducts(int result, const FString& msg, const std::string& data);
        void onPayment(int result, const FString& msg, const std::string& data);
        void onConsumePurchasedItems(int result, const FString& msg, const std::string& data);

    protected:
        IAPListener* _listener;
    };
}
